clear screen
set echo off
set termout off
alter session set query_rewrite_enabled = true;
alter session set query_rewrite_integrity = trusted;
set termout on
drop table t;
set echo on
clear screen
create table t ( x int not null, y int not null, z int );
insert into t values ( 5, 53, 1 );
insert into t values ( 50, 4, 1 );
insert into t values ( 40, 53, 1 );
insert into t values ( 5, 53, 1 );
insert into t values ( 50, 4, 1 );
insert into t values ( 40, 53, 1 );
pause
set linesize 121

clear screen
set autotrace on explain
select /*+ RULE */ x, y, sum(z) from t group by x, y
/
pause

clear screen
set autotrace on explain
select x, y, sum(z) from t group by x, y
/
pause

clear screen
create index t_idx on t(y,x,z);
pause

clear screen
select x, y, sum(z) from t group by x, y
/
pause

set autotrace off

clear screen
create or replace view v
as
select x, y, sum(z) "SUM(Z)" from t group by x, y order by x, y;

begin
	sys.dbms_advanced_rewrite.declare_rewrite_equivalence
	( name             => 'DEMO_TIME',
	  source_stmt      => 'select x, y, sum(z) from t group by x, y',
	  destination_stmt => 'select * from v',
	  validate         => FALSE,
	  rewrite_mode     => 'TEXT_MATCH' );
end;
/
pause


clear screen
set autotrace on explain
select x, y, sum(z) from t group by x, y
/
pause
clear screen
select x, y, sum(z) from t FOR_REAL group by x, y
/
set autotrace off
pause


clear screen
exec sys.dbms_advanced_rewrite.drop_rewrite_equivalence( 'DEMO_TIME' );
pause

clear screen
