
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned int magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* Object support */
struct sqltvn
{
  unsigned char *tvnvsn; 
  unsigned short tvnvsnl; 
  unsigned char *tvnnm;
  unsigned short tvnnml; 
  unsigned char *tvnsnm;
  unsigned short tvnsnml;
};
typedef struct sqltvn sqltvn;

struct sqladts
{
  unsigned int adtvsn; 
  unsigned short adtmode; 
  unsigned short adtnum;  
  sqltvn adttvn[1];       
};
typedef struct sqladts sqladts;

static struct sqladts sqladt = {
  1,1,0,
};

/* Binding to PL/SQL Records */
struct sqltdss
{
  unsigned int tdsvsn; 
  unsigned short tdsnum; 
  unsigned char *tdsval[1]; 
};
typedef struct sqltdss sqltdss;
static struct sqltdss sqltds =
{
  1,
  0,
};

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[5];
};
static struct sqlcxp sqlfpn =
{
    4,
    "t.pc"
};


static unsigned int sqlctx = 1083;


static struct sqlexd {
   unsigned int   sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   occurs;
            short *cud;
   unsigned char  *sqlest;
            char  *stmt;
   sqladts *sqladtp;
   sqltdss *sqltdsp;
            void  **sqphsv;
   unsigned int   *sqphsl;
            int   *sqphss;
            void  **sqpind;
            int   *sqpins;
   unsigned int   *sqparm;
   unsigned int   **sqparc;
   unsigned short  *sqpadto;
   unsigned short  *sqptdso;
   unsigned int   sqlcmax;
   unsigned int   sqlcmin;
   unsigned int   sqlcincr;
   unsigned int   sqlctimeout;
   unsigned int   sqlcnowait;
              int   sqfoff;
   unsigned int   sqcmod;
   unsigned int   sqfmod;
            void  *sqhstv[4];
   unsigned int   sqhstl[4];
            int   sqhsts[4];
            void  *sqindv[4];
            int   sqinds[4];
   unsigned int   sqharm[4];
   unsigned int   *sqharc[4];
   unsigned short  sqadto[4];
   unsigned short  sqtdso[4];
} sqlstm = {12,4};

/* SQLLIB Prototypes */
extern sqlcxt (/*_ void **, unsigned int *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2t(/*_ void **, unsigned int *,
                   struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuft(/*_ void **, char * _*/);
extern sqlgs2t(/*_ void **, char * _*/);
extern sqlorat(/*_ void **, unsigned int *, void * _*/);

/* Forms Interface */
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern void sqliem(/*_ char *, int * _*/);

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* CUD (Compilation Unit Data) Array */
static short sqlcud0[] =
{12,4130,1,0,0,
5,0,0,1,12,0,257,29,0,0,0,0,0,1,0,
20,0,0,2,34,0,300,33,0,0,0,0,0,1,0,
35,0,0,3,29,0,300,34,0,0,0,0,0,1,0,
50,0,0,4,60,0,280,37,0,0,0,0,0,1,0,
65,0,0,5,32,0,273,41,0,0,0,0,0,1,0,
80,0,0,6,36,0,259,46,0,0,1,1,0,1,0,1,3,0,0,
99,0,0,5,0,0,301,47,0,0,0,0,0,1,0,
114,0,0,7,0,0,283,67,0,0,4,4,0,1,0,1,9,0,0,1,10,0,0,1,10,0,0,1,10,0,0,
};


#line 1 "t.pc"
#include "unistd.h"
#include <stdio.h>
/* EXEC SQL INCLUDE sqlca;
 */ 
#line 1 "/home/ora10gr2/precomp/public/sqlca.h"
/*
 * $Header: sqlca.h 24-apr-2003.12:50:58 mkandarp Exp $ sqlca.h 
 */

/* Copyright (c) 1985, 2003, Oracle Corporation.  All rights reserved.  */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  **************************************************************
  ***                                                        ***
  *** This file is SOSD.  Porters must change the data types ***
  *** appropriately on their platform.  See notes/pcport.doc ***
  *** for more information.                                  ***
  ***                                                        ***
  **************************************************************

  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    lvbcheng   07/31/98 -  long to int
    jbasu      12/12/94 -  Bug 217878: note this is an SOSD file
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
         /* b4  */ int     sqlabc;
         /* b4  */ int     sqlcode;
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
         /* b4  */ int     sqlerrd[6];
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */

#line 4 "t.pc"

static void die(void)
{
char    errmsg[513];
int     length;
int     real_length = sizeof(errmsg);

    /* exec sql whenever sqlerror continue; */ 
#line 11 "t.pc"

    sqlglm( errmsg, &real_length, &length );
    errmsg[length] = 0;
    fprintf( stderr, "\n%s\n", errmsg );
    fprintf( stderr, "sqlcode = %d\n", sqlca.sqlcode );
    exit(1);
}



void process(void)
{
/* exec sql begin declare section; */ 
#line 23 "t.pc"

    int     i;
    int     empnos[10];
/* exec sql end declare section; */ 
#line 26 "t.pc"


    /* exec sql whenever sqlerror continue; */ 
#line 28 "t.pc"

    /* exec sql drop table t; */ 
#line 29 "t.pc"

{
#line 29 "t.pc"
    struct sqlexd sqlstm;
#line 29 "t.pc"
    sqlstm.sqlvsn = 12;
#line 29 "t.pc"
    sqlstm.arrsiz = 0;
#line 29 "t.pc"
    sqlstm.sqladtp = &sqladt;
#line 29 "t.pc"
    sqlstm.sqltdsp = &sqltds;
#line 29 "t.pc"
    sqlstm.stmt = "drop table t";
#line 29 "t.pc"
    sqlstm.iters = (unsigned int  )1;
#line 29 "t.pc"
    sqlstm.offset = (unsigned int  )5;
#line 29 "t.pc"
    sqlstm.cud = sqlcud0;
#line 29 "t.pc"
    sqlstm.sqlest = (unsigned char  *)&sqlca;
#line 29 "t.pc"
    sqlstm.sqlety = (unsigned short)256;
#line 29 "t.pc"
    sqlstm.occurs = (unsigned int  )0;
#line 29 "t.pc"
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
#line 29 "t.pc"
}

#line 29 "t.pc"

	printf( "Table dropped\n" );

    /* exec sql whenever sqlerror do die(); */ 
#line 32 "t.pc"

    /* exec sql create table t ( x char(2000) ); */ 
#line 33 "t.pc"

{
#line 33 "t.pc"
    struct sqlexd sqlstm;
#line 33 "t.pc"
    sqlstm.sqlvsn = 12;
#line 33 "t.pc"
    sqlstm.arrsiz = 0;
#line 33 "t.pc"
    sqlstm.sqladtp = &sqladt;
#line 33 "t.pc"
    sqlstm.sqltdsp = &sqltds;
#line 33 "t.pc"
    sqlstm.stmt = "create table t ( x char ( 2000 ) )";
#line 33 "t.pc"
    sqlstm.iters = (unsigned int  )1;
#line 33 "t.pc"
    sqlstm.offset = (unsigned int  )20;
#line 33 "t.pc"
    sqlstm.cud = sqlcud0;
#line 33 "t.pc"
    sqlstm.sqlest = (unsigned char  *)&sqlca;
#line 33 "t.pc"
    sqlstm.sqlety = (unsigned short)256;
#line 33 "t.pc"
    sqlstm.occurs = (unsigned int  )0;
#line 33 "t.pc"
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
#line 33 "t.pc"
    if (sqlca.sqlcode < 0) die();
#line 33 "t.pc"
}

#line 33 "t.pc"

	/* exec sql create index t_idx on t(x); */ 
#line 34 "t.pc"

{
#line 34 "t.pc"
 struct sqlexd sqlstm;
#line 34 "t.pc"
 sqlstm.sqlvsn = 12;
#line 34 "t.pc"
 sqlstm.arrsiz = 0;
#line 34 "t.pc"
 sqlstm.sqladtp = &sqladt;
#line 34 "t.pc"
 sqlstm.sqltdsp = &sqltds;
#line 34 "t.pc"
 sqlstm.stmt = "create index t_idx on t ( x )";
#line 34 "t.pc"
 sqlstm.iters = (unsigned int  )1;
#line 34 "t.pc"
 sqlstm.offset = (unsigned int  )35;
#line 34 "t.pc"
 sqlstm.cud = sqlcud0;
#line 34 "t.pc"
 sqlstm.sqlest = (unsigned char  *)&sqlca;
#line 34 "t.pc"
 sqlstm.sqlety = (unsigned short)256;
#line 34 "t.pc"
 sqlstm.occurs = (unsigned int  )0;
#line 34 "t.pc"
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
#line 34 "t.pc"
 if (sqlca.sqlcode < 0) die();
#line 34 "t.pc"
}

#line 34 "t.pc"

	printf( "Table indexed\n" );

	/* exec sql execute immediate
	"begin dbms_monitor.session_trace_enable( WAITS=>TRUE ); end;"; */ 
#line 38 "t.pc"

{
#line 37 "t.pc"
 struct sqlexd sqlstm;
#line 37 "t.pc"
 sqlstm.sqlvsn = 12;
#line 37 "t.pc"
 sqlstm.arrsiz = 0;
#line 37 "t.pc"
 sqlstm.sqladtp = &sqladt;
#line 37 "t.pc"
 sqlstm.sqltdsp = &sqltds;
#line 37 "t.pc"
 sqlstm.stmt = "begin dbms_monitor.session_trace_enable( WAITS=>TRUE ); end;";
#line 37 "t.pc"
 sqlstm.iters = (unsigned int  )1;
#line 37 "t.pc"
 sqlstm.offset = (unsigned int  )50;
#line 37 "t.pc"
 sqlstm.cud = sqlcud0;
#line 37 "t.pc"
 sqlstm.sqlest = (unsigned char  *)&sqlca;
#line 37 "t.pc"
 sqlstm.sqlety = (unsigned short)256;
#line 37 "t.pc"
 sqlstm.occurs = (unsigned int  )0;
#line 37 "t.pc"
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
#line 37 "t.pc"
 if (sqlca.sqlcode < 0) die();
#line 37 "t.pc"
}

#line 38 "t.pc"

	printf( "Tracing on\n" );

	/* exec sql prepare commit_stmt from "commit work write immediate wait"; */ 
#line 41 "t.pc"

{
#line 41 "t.pc"
 struct sqlexd sqlstm;
#line 41 "t.pc"
 sqlstm.sqlvsn = 12;
#line 41 "t.pc"
 sqlstm.arrsiz = 0;
#line 41 "t.pc"
 sqlstm.sqladtp = &sqladt;
#line 41 "t.pc"
 sqlstm.sqltdsp = &sqltds;
#line 41 "t.pc"
 sqlstm.stmt = "commit work write immediate wait";
#line 41 "t.pc"
 sqlstm.iters = (unsigned int  )1;
#line 41 "t.pc"
 sqlstm.offset = (unsigned int  )65;
#line 41 "t.pc"
 sqlstm.cud = sqlcud0;
#line 41 "t.pc"
 sqlstm.sqlest = (unsigned char  *)&sqlca;
#line 41 "t.pc"
 sqlstm.sqlety = (unsigned short)256;
#line 41 "t.pc"
 sqlstm.occurs = (unsigned int  )0;
#line 41 "t.pc"
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
#line 41 "t.pc"
 if (sqlca.sqlcode < 0) die();
#line 41 "t.pc"
}

#line 41 "t.pc"

	/* exec sql declare commit_curs cursor for commit_stmt; */ 
#line 42 "t.pc"


	for( i = 0; i < 1000; i++ )
	{
		/* exec sql insert into t values ( to_char(:i) ); */ 
#line 46 "t.pc"

{
#line 46 "t.pc"
  struct sqlexd sqlstm;
#line 46 "t.pc"
  sqlstm.sqlvsn = 12;
#line 46 "t.pc"
  sqlstm.arrsiz = 1;
#line 46 "t.pc"
  sqlstm.sqladtp = &sqladt;
#line 46 "t.pc"
  sqlstm.sqltdsp = &sqltds;
#line 46 "t.pc"
  sqlstm.stmt = "insert into t  values (to_char(:b0))";
#line 46 "t.pc"
  sqlstm.iters = (unsigned int  )1;
#line 46 "t.pc"
  sqlstm.offset = (unsigned int  )80;
#line 46 "t.pc"
  sqlstm.cud = sqlcud0;
#line 46 "t.pc"
  sqlstm.sqlest = (unsigned char  *)&sqlca;
#line 46 "t.pc"
  sqlstm.sqlety = (unsigned short)256;
#line 46 "t.pc"
  sqlstm.occurs = (unsigned int  )0;
#line 46 "t.pc"
  sqlstm.sqhstv[0] = (         void  *)&i;
#line 46 "t.pc"
  sqlstm.sqhstl[0] = (unsigned int  )sizeof(int);
#line 46 "t.pc"
  sqlstm.sqhsts[0] = (         int  )0;
#line 46 "t.pc"
  sqlstm.sqindv[0] = (         void  *)0;
#line 46 "t.pc"
  sqlstm.sqinds[0] = (         int  )0;
#line 46 "t.pc"
  sqlstm.sqharm[0] = (unsigned int  )0;
#line 46 "t.pc"
  sqlstm.sqadto[0] = (unsigned short )0;
#line 46 "t.pc"
  sqlstm.sqtdso[0] = (unsigned short )0;
#line 46 "t.pc"
  sqlstm.sqphsv = sqlstm.sqhstv;
#line 46 "t.pc"
  sqlstm.sqphsl = sqlstm.sqhstl;
#line 46 "t.pc"
  sqlstm.sqphss = sqlstm.sqhsts;
#line 46 "t.pc"
  sqlstm.sqpind = sqlstm.sqindv;
#line 46 "t.pc"
  sqlstm.sqpins = sqlstm.sqinds;
#line 46 "t.pc"
  sqlstm.sqparm = sqlstm.sqharm;
#line 46 "t.pc"
  sqlstm.sqparc = sqlstm.sqharc;
#line 46 "t.pc"
  sqlstm.sqpadto = sqlstm.sqadto;
#line 46 "t.pc"
  sqlstm.sqptdso = sqlstm.sqtdso;
#line 46 "t.pc"
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
#line 46 "t.pc"
  if (sqlca.sqlcode < 0) die();
#line 46 "t.pc"
}

#line 46 "t.pc"

        /* exec sql open commit_curs; */ 
#line 47 "t.pc"

{
#line 47 "t.pc"
        struct sqlexd sqlstm;
#line 47 "t.pc"
        sqlstm.sqlvsn = 12;
#line 47 "t.pc"
        sqlstm.arrsiz = 1;
#line 47 "t.pc"
        sqlstm.sqladtp = &sqladt;
#line 47 "t.pc"
        sqlstm.sqltdsp = &sqltds;
#line 47 "t.pc"
        sqlstm.stmt = "";
#line 47 "t.pc"
        sqlstm.iters = (unsigned int  )1;
#line 47 "t.pc"
        sqlstm.offset = (unsigned int  )99;
#line 47 "t.pc"
        sqlstm.selerr = (unsigned short)1;
#line 47 "t.pc"
        sqlstm.cud = sqlcud0;
#line 47 "t.pc"
        sqlstm.sqlest = (unsigned char  *)&sqlca;
#line 47 "t.pc"
        sqlstm.sqlety = (unsigned short)256;
#line 47 "t.pc"
        sqlstm.occurs = (unsigned int  )0;
#line 47 "t.pc"
        sqlstm.sqcmod = (unsigned int )0;
#line 47 "t.pc"
        sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
#line 47 "t.pc"
        if (sqlca.sqlcode < 0) die();
#line 47 "t.pc"
}

#line 47 "t.pc"

	}
	printf( "Done...\n" );
}


main( argc, argv )
int    argc;
char *    argv[];
{
/* EXEC SQL BEGIN DECLARE SECTION; */ 
#line 57 "t.pc"

/* varchar   oracleid[31]; */ 
struct { unsigned short len; unsigned char arr[31]; } oracleid;
#line 58 "t.pc"

int       i;
char      stmt[255];
/* EXEC SQL END DECLARE SECTION; */ 
#line 61 "t.pc"


    strcpy( (char *)oracleid.arr, "scott/tiger" );
    oracleid.len = strlen((char *)oracleid.arr);
    /* EXEC SQL WHENEVER SQLERROR DO die(); */ 
#line 65 "t.pc"

    printf( "connecting \n" );
    /* EXEC SQL CONNECT :oracleid; */ 
#line 67 "t.pc"

{
#line 67 "t.pc"
    struct sqlexd sqlstm;
#line 67 "t.pc"
    sqlstm.sqlvsn = 12;
#line 67 "t.pc"
    sqlstm.arrsiz = 4;
#line 67 "t.pc"
    sqlstm.sqladtp = &sqladt;
#line 67 "t.pc"
    sqlstm.sqltdsp = &sqltds;
#line 67 "t.pc"
    sqlstm.iters = (unsigned int  )10;
#line 67 "t.pc"
    sqlstm.offset = (unsigned int  )114;
#line 67 "t.pc"
    sqlstm.cud = sqlcud0;
#line 67 "t.pc"
    sqlstm.sqlest = (unsigned char  *)&sqlca;
#line 67 "t.pc"
    sqlstm.sqlety = (unsigned short)256;
#line 67 "t.pc"
    sqlstm.occurs = (unsigned int  )0;
#line 67 "t.pc"
    sqlstm.sqhstv[0] = (         void  *)&oracleid;
#line 67 "t.pc"
    sqlstm.sqhstl[0] = (unsigned int  )33;
#line 67 "t.pc"
    sqlstm.sqhsts[0] = (         int  )33;
#line 67 "t.pc"
    sqlstm.sqindv[0] = (         void  *)0;
#line 67 "t.pc"
    sqlstm.sqinds[0] = (         int  )0;
#line 67 "t.pc"
    sqlstm.sqharm[0] = (unsigned int  )0;
#line 67 "t.pc"
    sqlstm.sqadto[0] = (unsigned short )0;
#line 67 "t.pc"
    sqlstm.sqtdso[0] = (unsigned short )0;
#line 67 "t.pc"
    sqlstm.sqphsv = sqlstm.sqhstv;
#line 67 "t.pc"
    sqlstm.sqphsl = sqlstm.sqhstl;
#line 67 "t.pc"
    sqlstm.sqphss = sqlstm.sqhsts;
#line 67 "t.pc"
    sqlstm.sqpind = sqlstm.sqindv;
#line 67 "t.pc"
    sqlstm.sqpins = sqlstm.sqinds;
#line 67 "t.pc"
    sqlstm.sqparm = sqlstm.sqharm;
#line 67 "t.pc"
    sqlstm.sqparc = sqlstm.sqharc;
#line 67 "t.pc"
    sqlstm.sqpadto = sqlstm.sqadto;
#line 67 "t.pc"
    sqlstm.sqptdso = sqlstm.sqtdso;
#line 67 "t.pc"
    sqlstm.sqlcmax = (unsigned int )100;
#line 67 "t.pc"
    sqlstm.sqlcmin = (unsigned int )2;
#line 67 "t.pc"
    sqlstm.sqlcincr = (unsigned int )1;
#line 67 "t.pc"
    sqlstm.sqlctimeout = (unsigned int )0;
#line 67 "t.pc"
    sqlstm.sqlcnowait = (unsigned int )0;
#line 67 "t.pc"
    sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
#line 67 "t.pc"
    if (sqlca.sqlcode < 0) die();
#line 67 "t.pc"
}

#line 67 "t.pc"

    printf( "connected \n" );

    /* EXEC SQL WHENEVER SQLERROR DO die(); */ 
#line 70 "t.pc"

    process();

    exit(0);
}
